// Copyright (c) 2016, 2018, 2022, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Fusion Applications Environment Management API
//
// Use the Fusion Applications Environment Management API to manage the environments where your Fusion Applications run. For more information, see the Fusion Applications Environment Management documentation (https://docs.cloud.oracle.com/iaas/Content/fusion-applications/home.htm).
//

package fusionapps

import (
	"fmt"
	"github.com/oracle/oci-go-sdk/v65/common"
	"strings"
)

// FawAdminInfoDetails Admin information to provision Analytics Warehouse Service.
type FawAdminInfoDetails struct {

	// Password for the ADW to be created in User Tenancy
	AdwAdminPass *string `mandatory:"true" json:"adwAdminPass"`

	// Email ID to send notification for Analytics Warehouse updates.
	NotificationEmail *string `mandatory:"true" json:"notificationEmail"`

	// Password for the auto-created FAWService user
	FawServicePass *string `mandatory:"false" json:"fawServicePass"`
}

func (m FawAdminInfoDetails) String() string {
	return common.PointerString(m)
}

// ValidateEnumValue returns an error when providing an unsupported enum value
// This function is being called during constructing API request process
// Not recommended for calling this function directly
func (m FawAdminInfoDetails) ValidateEnumValue() (bool, error) {
	errMessage := []string{}

	if len(errMessage) > 0 {
		return true, fmt.Errorf(strings.Join(errMessage, "\n"))
	}
	return false, nil
}
